/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.11.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

var util = require('util');

/**
 * @class
 * Initializes a new instance of the ProductResult class.
 * @constructor
 */
function ProductResult() { }

/**
 * Validate the payload against the ProductResult schema
 *
 * @param {JSON} payload
 *
 */
ProductResult.prototype.validate = function (payload) {
  if (!payload) {
    throw new Error('ProductResult cannot be null.');
  }
  if (util.isArray(payload['values'])) {
    for (var i = 0; i < payload['values'].length; i++) {
      if (payload['values'][i]) {
        models['Product'].validate(payload['values'][i]);
      }
    }
  }

  if (payload['nextLink'] !== null && payload['nextLink'] !== undefined && typeof payload['nextLink'].valueOf() !== 'string') {
    throw new Error('payload[\'nextLink\'] must be of type string.');
  }
};

/**
 * Deserialize the instance to ProductResult schema
 *
 * @param {JSON} instance
 *
 */
ProductResult.prototype.deserialize = function (instance) {
  if (instance) {
    if (instance.values !== null && instance.values !== undefined) {
      var deserializedArray = [];
      instance.values.forEach(function(element) {
        if (element !== null && element !== undefined) {
          element = models['Product'].deserialize(element);
        }
        deserializedArray.push(element);
      });
      instance.values = deserializedArray;
    }
  }
  return instance;
};

module.exports = new ProductResult();
